using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using Negocio;

namespace Forms {
    public partial class CImagen : UserControl {

        private EImagen obj = null;

        public CImagen(EImagen imagen) {
            InitializeComponent();
            obj = imagen;
        }

        private void CImagen_Load(object sender, EventArgs e) {
            if (EUsuario.Actual.GetMayorPermiso().Tipo == TipoPermiso.Publico) {
                btAmpliar.Location = new Point(lblNombreImagen.Location.X, btAmpliar.Location.Y);
                chbEliminar.Visible = false;
            }
            if (obj != null) {
                bind.Add(obj);
            }
        }

        private void btAmpliar_Click(object sender, EventArgs e) {
            if (obj != null) {
                FImagen fimagen = new FImagen();
                fimagen.Cargar(obj);
                fimagen.ShowDialog();
            } else {
                MessageBox.Show("No se puede ampliar la imagen por que no existe.", "INFO", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
        }

        public EImagen Extraer() {
            return obj;
        }

        public bool EstaSeleccionado() {
            return chbEliminar.Visible && chbEliminar.Checked;
        }
    }
}
