using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using Negocio;
using Nibi.Negocio;

namespace Forms {
    public partial class CMuestraAbandono : UserControl {

        private EClasificacionCarreraCampeonato objClasificacionCampeonato = null;
        private EClasificacionCarrera objClasificacionCarrera = null;
        //TODO: faltaria la entidad con puntos.

        public CMuestraAbandono() {
            InitializeComponent();
        }

        private void CMuestraAbandono_Load(object sender, EventArgs e) {

        }

        public void Cargar(ESinClaveBase entidad) {
            if (entidad == null) {
                throw new ArgumentNullException("La entidad no puede estar vaca.");
            }
            objClasificacionCampeonato = entidad as EClasificacionCarreraCampeonato;
            objClasificacionCarrera = entidad as EClasificacionCarrera;
            if (objClasificacionCampeonato == null && objClasificacionCarrera == null) {
                throw new InvalidCastException("La entidad debe ser de los tipos EClasificacionCarreraCampeonato o EClasificacionCarrera.");
            }
            if (objClasificacionCarrera != null) {
                MostrarDatosInscrito(objClasificacionCarrera.PilotoCarrera);
                lblMotivo.Text = objClasificacionCarrera.MotivoToString;
            } else if (objClasificacionCampeonato != null) {
                MostrarDatosInscrito(objClasificacionCampeonato.ClasificacionCarrera.PilotoCarrera);
                lblMotivo.Text = objClasificacionCampeonato.ClasificacionCarrera.MotivoToString;
            }
        }

        private void MostrarDatosInscrito(EPilotoCarrera ePilotoCarrera) {
            lblDorsal.Text = ePilotoCarrera.Dorsal.ToString();
            lblNombrePiloto.Text = ePilotoCarrera.Piloto.ToString();
            lblVehiculo.Text = ePilotoCarrera.Vehiculo.Marca + " " + ePilotoCarrera.Vehiculo.Modelo;
            if (ePilotoCarrera.Piloto.Escuderia != null) {
                lblEscuderia.Text = ePilotoCarrera.Piloto.Escuderia.ToString();
            } else {
                lblEscuderia.Text = "..........";
            }
            if (ePilotoCarrera.Copiloto != null) {
                lblNombrePiloto.Text = lblNombrePiloto.Text + "\n" + ePilotoCarrera.Copiloto.ToString();
                Point punto = new Point();
                punto.X = lblNombrePiloto.Location.X;
                punto.Y = lblNombrePiloto.Location.Y - 8;
                lblNombrePiloto.Location = punto;
            }
        }
    }
}
