using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using Negocio;
using Nibi.Negocio;

namespace Forms {
    public partial class CMuestraClasificacionCarrera : UserControl {

        private EClasificacionCarreraCampeonato objClasificacionCampeonato = null;
        private EClasificacionCarrera objClasificacionCarrera = null;
        private bool mconPuntos = false;

        public CMuestraClasificacionCarrera() {
            InitializeComponent();
        }

        private void CMuestraClasificacionTiempo_Load(object sender, EventArgs e) {
            
        }

        public void Cargar(ESinClaveBase entidad, bool conPuntos) {
            mconPuntos = conPuntos;
            this.Cargar(entidad);
        }

        public void Cargar(ESinClaveBase entidad) {
            if (entidad == null) {
                throw new ArgumentNullException("La entidad no puede estar vaca.");
            }
            objClasificacionCampeonato = entidad as EClasificacionCarreraCampeonato;
            objClasificacionCarrera = entidad as EClasificacionCarrera;
            if (objClasificacionCampeonato == null && objClasificacionCarrera == null) {
                throw new InvalidCastException("La entidad debe ser de los tipos EClasificacionCarreraCampeonato o EClasificacionCarrera o EClasificacionGeneralBase.");
            }
            if (objClasificacionCarrera != null) {
                MostrarDatosInscrito(objClasificacionCarrera.PilotoCarrera);
                lblPuesto.Text = objClasificacionCarrera.Puesto.ToString();
                MostrarTiempo(lblTiempoPuntos, objClasificacionCarrera.TiempoEfectivo);
                if (objClasificacionCarrera.TiempoAnterior.HasValue) {
                    TimeSpan diferencia = objClasificacionCarrera.TiempoEfectivo.Subtract(objClasificacionCarrera.TiempoAnterior.Value);
                    MostrarTiempo(lblDifAnterior, diferencia);
                } else {
                    lblDifAnterior.Text = "..........";
                }
                if (objClasificacionCarrera.TiempoPrimero.HasValue) {
                    TimeSpan diferencia = objClasificacionCarrera.TiempoEfectivo.Subtract(objClasificacionCarrera.TiempoPrimero.Value);
                    MostrarTiempo(lblDifPrimero, diferencia);
                } else {
                    lblDifPrimero.Text = "..........";
                }
            } else if (objClasificacionCampeonato != null) {
                MostrarDatosInscrito(objClasificacionCampeonato.ClasificacionCarrera.PilotoCarrera);
                lblPuesto.Text = objClasificacionCampeonato.Puesto.ToString();
                EClasificacionCarreraCampeonatoConPuntos clasifConPuntos = entidad as EClasificacionCarreraCampeonatoConPuntos;
                if (clasifConPuntos != null && mconPuntos) {
                    lblTiempoPuntos.Text = clasifConPuntos.Puntos.ToString();
                    if (clasifConPuntos.PuntosAnterior.HasValue) {
                        int diferencia = clasifConPuntos.PuntosAnterior.Value - clasifConPuntos.Puntos;
                        lblDifAnterior.Text = diferencia.ToString();
                    } else {
                        lblDifAnterior.Text = "..........";
                    }
                    if (clasifConPuntos.PuntosPrimero.HasValue) {
                        int diferencia = clasifConPuntos.PuntosPrimero.Value - clasifConPuntos.Puntos;
                        lblDifPrimero.Text = diferencia.ToString();
                    } else {
                        lblDifPrimero.Text = "..........";
                    }
                } else {
                    MostrarTiempo(lblTiempoPuntos, objClasificacionCampeonato.ClasificacionCarrera.TiempoEfectivo);
                    if (objClasificacionCampeonato.TiempoAnterior.HasValue) {
                        TimeSpan diferencia = objClasificacionCampeonato.Tiempo.Subtract(objClasificacionCampeonato.TiempoAnterior.Value);
                        MostrarTiempo(lblDifAnterior, diferencia);
                    } else {
                        lblDifAnterior.Text = "..........";
                    }
                    if (objClasificacionCampeonato.TiempoPrimero.HasValue) {
                        TimeSpan diferencia = objClasificacionCampeonato.Tiempo.Subtract(objClasificacionCampeonato.TiempoPrimero.Value);
                        MostrarTiempo(lblDifPrimero, diferencia);
                    } else {
                        lblDifPrimero.Text = "..........";
                    }
                }
            } 
        }

        private void MostrarTiempo(Label etiqueta, TimeSpan timeSpan) {
            etiqueta.Text = CToString.ToString(timeSpan);
        }

        private void MostrarDatosInscrito(EPilotoCarrera ePilotoCarrera) {
            lblDorsal.Text = ePilotoCarrera.Dorsal.ToString();
            lblNombrePiloto.Text = ePilotoCarrera.Piloto.ToString();
            lblVehiculo.Text = ePilotoCarrera.Vehiculo.Marca + " " + ePilotoCarrera.Vehiculo.Modelo;
            if (ePilotoCarrera.Piloto.Escuderia != null) {
                lblEscuderia.Text = ePilotoCarrera.Piloto.Escuderia.ToString();
            } else {
                lblEscuderia.Text = "..........";
            }
            if (ePilotoCarrera.Copiloto != null) {
                lblNombrePiloto.Text = lblNombrePiloto.Text + "\n" + ePilotoCarrera.Copiloto.ToString();
                Point punto = new Point();
                punto.X = lblNombrePiloto.Location.X;
                punto.Y = lblNombrePiloto.Location.Y - 8;
                lblNombrePiloto.Location = punto;
            }
        }
    }
}
