using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using Negocio;
using Nibi.Negocio;

namespace Forms {
    public partial class CMuestraClasificacionGeneral : UserControl {

        private EClasificacionGeneralBase obj = null;

        public CMuestraClasificacionGeneral() {
            InitializeComponent();
        }

        private void CMuestraClasificacionGeneral_Load(object sender, EventArgs e) {

        }

        public void Cargar(ESinClaveBase entidad) {
            if (entidad == null) {
                throw new ArgumentNullException("La entidad no puede ser vaca.");
            }
            obj = entidad as EClasificacionGeneralBase;
            if (obj == null) {
                throw new InvalidCastException("La entidad debe ser de tipo EClasificacionGeneralBase.");
            }
            lblPuesto.Text = obj.Puesto.ToString();
            lblPuntos.Text = obj.Puntos.ToString();
            if (obj.PuntosAnterior.HasValue) {
                int num = obj.PuntosAnterior.Value - obj.Puntos;
                lblDifAnterior.Text = num.ToString();
            } else {
                lblDifAnterior.Text = "..........";
            }
            if (obj.PuntosPrimero.HasValue) {
                int num = obj.PuntosPrimero.Value - obj.Puntos;
                lblDifPrimero.Text = num.ToString();
            } else {
                lblDifPrimero.Text = "..........";
            }
            EClasificacionGeneralPareja objPareja = obj as EClasificacionGeneralPareja;
            EClasificacionGeneralParticipante objParticipante = obj as EClasificacionGeneralParticipante;
            if (objParticipante != null) {
                lblNombreConcursante.Text = objParticipante.Participante.ToString();
            } else if (objPareja != null) {
                lblNombreConcursante.Text = objPareja.Pareja.ToString();
            } else {
                throw new Exception("Fatal Error");
            }
        }
    }
}
