using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Nibi.Negocio;

namespace Forms {
    public partial class FDialogo : Form, IFiltroBuscar {

        private IEColeccion mColeccion = null;
        private CBusqueda cBuscar = null;

        public FDialogo(IEColeccion col) {
            InitializeComponent();
            mColeccion = col;
        }

        private void FDialogo_Load(object sender, EventArgs e) {
            dgv.DataSource = mColeccion;
            cBuscar = new CBusqueda(mColeccion);
            gbBusqueda.Controls.Add(cBuscar);
            cBuscar.Dock = DockStyle.Fill;
            cBuscar.Show();
        }

        private void btOk_Click(object sender, EventArgs e) {
            if(dgv.CurrentRow != null) {
                this.DialogResult = DialogResult.OK;
                this.Close();
            } else {
                MessageBox.Show("Debe elegir una fila.", "INFO", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void btCancelar_Click(object sender, EventArgs e) {
            this.Close();
        }

        public ESinClaveBase ExtraerEleccion(){
            try {
                ESinClaveBase e = (ESinClaveBase)dgv.CurrentRow.DataBoundItem;
                if(e == null) {
                    MessageBox.Show("Error al recuperar. Vuelva a intentarlo.", "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                return e;
            } catch(Exception ex) {
                MessageBox.Show(ex.Message, "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return null;
            }
        }

        #region IFiltroBuscar

        public void Aplicar(IEColeccion col) {
            dgv.DataSource = col;
        }

        #endregion
    }
}