using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Negocio;
using Nibi.Negocio;
using System.Collections.ObjectModel;

namespace Forms {
    public partial class FElegir : Form {

        private EColeccion<ECronometrable> mColeccionCronometrables = null;
        private ECarrera carrera = null;
        private string cadenaRally = null;
        private object obj = null;
        private Collection<KeyValuePair<Enum,string>> collection = null;

        public FElegir() {
            InitializeComponent();
        }

        public FElegir(ECarrera obj) : this() {
            carrera = obj;
        }

        public FElegir(ECarrera obj, string s) : this() {
            carrera = obj;
            cadenaRally = s;
        }

        public FElegir(Collection<KeyValuePair<Enum, string>> col): this() {
            collection = col;
        }

        private void FElegir_Load(object sender, EventArgs e) {
            if (carrera != null) {
                mColeccionCronometrables = carrera.Cronometrables;
                if (cadenaRally != null) {
                    lbLista.Items.Add(cadenaRally);

                }
                foreach (ECronometrable crono in mColeccionCronometrables) {
                    if (cadenaRally != null && crono.Tipo == TipoCronometrable.Tramo) {
                        lbLista.Items.Add(crono);
                    } else if (cadenaRally == null) {
                        lbLista.Items.Add(crono);
                    }
                }
                switch (carrera.Tipo) {
                    case TipoCarrera.Subida:
                        lblElegir.Text = "ELIJA UNA MANGA DE UNA FASE";
                        break;
                    case TipoCarrera.Rally:
                        if (String.IsNullOrEmpty(cadenaRally)) {
                            lblElegir.Text = "ELIJA UN TRAMO O UN SECTOR";
                        } else {
                            lblElegir.Text = "ELIJA UN TRAMO O LA CARRERA COMPLETA.";
                        }
                        break;
                    default:
                        lblElegir.Text = "";
                        btOK.Enabled = false;
                        break;
                }
            } else {
                foreach (KeyValuePair<Enum,string> kvp in collection) {
                    lbLista.Items.Add(kvp.Value);
                }
                lblElegir.Text = "ELIJA UN TIPO DE DOCUMENTO.";
            }
        }

        private void btOK_Click(object sender, EventArgs e) {
            if (lbLista.SelectedIndex >= 0) {
                if (carrera == null) {//keyvaluepair
                    bool terminado = false;
                    int indice = 0;
                    while (!terminado && indice < collection.Count) {
                        if (collection[indice].Value.Equals(lbLista.SelectedItem)) {
                            terminado = true;
                            obj = collection[indice];
                        }
                        indice = indice + 1;
                    }
                } else {
                    obj = lbLista.SelectedItem as object;        
                }
                this.DialogResult = DialogResult.OK;
                this.Close();
            } else {
                MessageBox.Show("Debe elegir una fila.", "INFO", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void btCancelar_Click(object sender, EventArgs e) {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }

        public object Devolver() {
            if (!String.IsNullOrEmpty(cadenaRally) && obj == null) {
                return cadenaRally;
            }
            return obj;
        }
    }
}