using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Negocio;
using Nibi.Negocio;

namespace Forms {
    public partial class FCronoSector : Form, IFichaEntidad {

        private ETiempoPilotoSector obj = null;
        private bool EstaCargado = false;

        public FCronoSector() {
            InitializeComponent();
        }

        public FCronoSector(ETiempoPilotoSector tiempoSector) : this() {
            obj = tiempoSector;
        }

        private void FCronoSector_Load(object sender, EventArgs e) {
            if (this.Parent != null) {
                this.SetStyle(ControlStyles.SupportsTransparentBackColor, true);
                this.BackColor = Color.Transparent;
            }
            if (!EstaCargado) {
                Cargar(obj);
            }
        }

        #region IFichaEntidad

        public void Cargar(object entidad) {
            if (entidad == null) {
                throw new ArgumentNullException("La entidad no puede estar vaca.");
            }
            obj = entidad as ETiempoPilotoSector;
            if (obj == null) {
                throw new InvalidCastException("La entidad debe ser de tipo ETiempoPilotoSector.");
            }
            //limpiamos los bind
            bind.Clear();
            //
            bind.Add(obj);
            obj.PropertyChanged += new PropertyChangedEventHandler(obj_PropertyChanged);
            EstaCargado = true;
            this.obj_PropertyChanged(null, new PropertyChangedEventArgs(ETiempoPilotoSector.NPHoraLLegada));
            this.obj_PropertyChanged(null, new PropertyChangedEventArgs(ETiempoPilotoSector.NPHoraSalida));
            this.obj_PropertyChanged(null, new PropertyChangedEventArgs(ETiempoPilotoSector.NPMinutosLLegada));
            this.obj_PropertyChanged(null, new PropertyChangedEventArgs(ETiempoPilotoSector.NPMinutosSalida));
            this.obj_PropertyChanged(null, new PropertyChangedEventArgs(ETiempoPilotoSector.NPSegundosLLegada));
            this.obj_PropertyChanged(null, new PropertyChangedEventArgs(ETiempoPilotoSector.NPSegundosSalida));
            this.obj_PropertyChanged(null, new PropertyChangedEventArgs(ETiempoPilotoSector.NPMilesimasLLegada));
            this.obj_PropertyChanged(null, new PropertyChangedEventArgs(ETiempoPilotoSector.NPMilesimasSalida));
            //EstaCerrada.
            txtHoraLLegada.ReadOnly = txtHoraSalida.ReadOnly = txtMilesimasLLegada.ReadOnly = txtMilesimasSalida.ReadOnly =
                txtMinutosLLegada.ReadOnly = txtMinutosSalida.ReadOnly = txtSegundosLLegada.ReadOnly = txtSegundosSalida.ReadOnly = this.obj.Cronometrable.Carrera.EstaCerrada;
        }

        void obj_PropertyChanged(object sender, PropertyChangedEventArgs e) {
            PropertyException pe = null;
            if (e.PropertyName.Equals(ETiempoPilotoSector.NPHoraLLegada)) {
                pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPHoraLLegada);
                if (pe != null) {
                    errProv.SetError(txtHoraLLegada, pe.Message);
                } else {
                    errProv.SetError(txtHoraLLegada, "");
                    pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPTiempoLLegada);
                    if (pe != null) {
                        errProv.SetError(lblTiempoLLegada, pe.Message);
                    } else {
                        errProv.SetError(lblTiempoLLegada, "");
                        errProv.SetError(lblTiempoSalida, "");
                    }
                }
            } else if (e.PropertyName.Equals(ETiempoPilotoSector.NPMinutosLLegada)) {
                pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPMinutosLLegada);
                if (pe != null) {
                    errProv.SetError(txtMinutosLLegada, pe.Message);
                } else {
                    errProv.SetError(txtMinutosLLegada, "");
                    pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPTiempoLLegada);
                    if (pe != null) {
                        errProv.SetError(lblTiempoLLegada, pe.Message);
                    } else {
                        errProv.SetError(lblTiempoLLegada, "");
                        errProv.SetError(lblTiempoSalida, "");
                    }
                }
            } else if (e.PropertyName.Equals(ETiempoPilotoSector.NPSegundosLLegada)) {
                pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPSegundosLLegada);
                if (pe != null) {
                    errProv.SetError(txtSegundosLLegada, pe.Message);
                } else {
                    errProv.SetError(txtSegundosLLegada, "");
                    pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPTiempoLLegada);
                    if (pe != null) {
                        errProv.SetError(lblTiempoLLegada, pe.Message);
                    } else {
                        errProv.SetError(lblTiempoLLegada, "");
                        errProv.SetError(lblTiempoSalida, "");
                    }
                }
            } else if (e.PropertyName.Equals(ETiempoPilotoSector.NPMilesimasLLegada)) {
                pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPMilesimasLLegada);
                if (pe != null) {
                    errProv.SetError(txtMilesimasLLegada, pe.Message);
                } else {
                    errProv.SetError(txtMilesimasLLegada, "");
                    pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPTiempoLLegada);
                    if (pe != null) {
                        errProv.SetError(lblTiempoLLegada, pe.Message);
                    } else {
                        errProv.SetError(lblTiempoLLegada, "");
                        errProv.SetError(lblTiempoSalida, "");
                    }
                }
            } else if (e.PropertyName.Equals(ETiempoPilotoSector.NPHoraSalida)) {
                pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPHoraSalida);
                if (pe != null) {
                    errProv.SetError(txtHoraSalida, pe.Message);
                } else {
                    errProv.SetError(txtHoraSalida, "");
                    pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPTiempoSalida);
                    if (pe != null) {
                        errProv.SetError(lblTiempoSalida, pe.Message);
                    } else {
                        errProv.SetError(lblTiempoSalida, "");
                        errProv.SetError(lblTiempoLLegada, "");
                    }
                }
            } else if (e.PropertyName.Equals(ETiempoPilotoSector.NPMinutosSalida)) {
                pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPMinutosSalida);
                if (pe != null) {
                    errProv.SetError(txtMinutosSalida, pe.Message);
                } else {
                    errProv.SetError(txtMinutosSalida, "");
                    pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPTiempoSalida);
                    if (pe != null) {
                        errProv.SetError(lblTiempoSalida, pe.Message);
                    } else {
                        errProv.SetError(lblTiempoSalida, "");
                        errProv.SetError(lblTiempoLLegada, "");
                    }
                }
            }else if (e.PropertyName.Equals(ETiempoPilotoSector.NPSegundosSalida)) {
                pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPSegundosSalida);
                if (pe != null) {
                    errProv.SetError(txtSegundosSalida, pe.Message);
                } else {
                    errProv.SetError(txtSegundosSalida, "");
                    pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPTiempoSalida);
                    if (pe != null) {
                        errProv.SetError(lblTiempoSalida, pe.Message);
                    } else {
                        errProv.SetError(lblTiempoSalida, "");
                        errProv.SetError(lblTiempoLLegada, "");
                    }
                }
            } else if (e.PropertyName.Equals(ETiempoPilotoSector.NPMilesimasSalida)) {
                pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPMilesimasSalida);
                if (pe != null) {
                    errProv.SetError(txtMilesimasSalida, pe.Message);
                } else {
                    errProv.SetError(txtMilesimasSalida, "");
                    pe = obj.ErrorDePropiedad(ETiempoPilotoSector.NPTiempoSalida);
                    if (pe != null) {
                        errProv.SetError(lblTiempoSalida, pe.Message);
                    } else {
                        errProv.SetError(lblTiempoSalida, "");
                        errProv.SetError(lblTiempoLLegada, "");
                    }
                }
            }
        }

        /// <summary>
        /// En este formulario no se aplica.
        /// </summary>
        public void CrearNuevo() {
            throw new Exception("El mtodo crear nuevo no se impelementa en este formulario.");
        }

        #endregion

        private void btSancion_Click(object sender, EventArgs e) {
            DialogResult dr = MessageBox.Show("Quiere crear una sancin?", "Crear Sancin", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            if (dr == DialogResult.Yes) {
                ESancion sancion = new ESancion();
                sancion.Cronometrable = obj.Cronometrable;
                sancion.PilotoCarrera = obj.PilotoCarrera;
                FSancion fs = new FSancion();
                fs.Cargar(sancion);
                fs.ShowDialog();
            }
        }
    }
}