using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Nibi.Negocio;

namespace Forms {
    public partial class FDialogo : Form {

        private IEColeccion mColeccion = null;

        public FDialogo() {
            InitializeComponent();
        }

        public FDialogo(IEColeccion col):this() {
            mColeccion = col;
        }

        private void FDialogo_Load(object sender, EventArgs e) {
            dgv.DataSource = mColeccion;
        }

        private void btOk_Click(object sender, EventArgs e) {
            if(dgv.CurrentRow != null) {
                this.Close();
            } else {
                MessageBox.Show("Debe elegir una fila.", "INFO", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void btCancelar_Click(object sender, EventArgs e) {
            this.Close();
        }

        public ESinClaveBase ExtraerEleccion(){
            try {
                ESinClaveBase e = (ESinClaveBase)dgv.CurrentRow.DataBoundItem;
                if(e == null) {
                    MessageBox.Show("Error al recuperar. Vuelva a intentarlo.", "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                return e;
            } catch(Exception ex) {
                MessageBox.Show(ex.Message, "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return null;
            }
        }
    }
}