using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Nibi.Negocio;
using Negocio;
using System.Collections.ObjectModel;

namespace Forms {
    public partial class FMuestraParticipante : Form, IFichaEntidad, IPestanha, IFichaMultiEntidad {

        EParticipante obj = null;

        public FMuestraParticipante() {
            InitializeComponent();
        }

        private void FMuestraParticipante_Load(object sender, EventArgs e) {
            if (obj != null) {
                bind.ResetCurrentItem();
            }
            if (this.Parent != null) {
                this.SetStyle(ControlStyles.SupportsTransparentBackColor, true);
                this.BackColor = Color.Transparent;
            }
        }

        #region IFichaEntidad

        public void Cargar(object entidad) {
            if (entidad == null) {
                throw new ArgumentNullException("Participante.");
            }
            if (obj != null) {//Este form ya estaba en ejecucin
                bind.Clear();
            }
            obj = entidad as EParticipante;
            if (obj == null) {
                throw new InvalidCastException("La entidad de este formulario debe ser de tipo EParticipante.");
            }
            bind.Add(obj);
            if (obj.Escuderia != null) {
                pbLogoEscuderia.Visible = true;
                pbLogoEscuderia.Image = obj.Escuderia.Logo;
            } else {
                pbLogoEscuderia.Visible = false;
            }
        }

        /// <summary>
        /// No se implementa, este form es solo para mostrar detalles.
        /// </summary>
        public void CrearNuevo() {
            throw new Exception("Este formulario no implementa el mtodo crear Nuevo.");
        }

        #endregion

        #region IPestanha

        public Collection<Pestanha> ExtraerPestanhas() {
            Collection<Pestanha> col = new Collection<Pestanha>();
            FColeccion fcolCarreras = new FColeccion(TipoColeccion.CarrerasParticipadas);
            fcolCarreras.TopLevel = false;
            fcolCarreras.FormBorderStyle = FormBorderStyle.None;
            col.Add(new Pestanha("Carreras Participadas", fcolCarreras));
            return col;
        }

        public ESinClaveBase ObjFicha() {
            return obj;
        }

        #endregion

        #region IFichaMultiEntidad

        /// <summary>
        /// Este mtodo no se implementa en este form.
        /// </summary>
        /// <param name="tipoEntidad"></param>
        public void CrearNuevo(Type tipoEntidad) {
            throw new Exception("Este mtodo no se implementa");
        }

        #endregion
    }
}