using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Nibi.Negocio;
using Negocio;

namespace Forms {
    public partial class FVistaInforme : Form {

        /// <summary>
        /// Ubicacin del nombre con extensin .rdlc
        /// </summary>
        /// <param name="nombreInforme"></param>
        public FVistaInforme(string nombreInforme) {
            InitializeComponent();
            rv.LocalReport.ReportEmbeddedResource = nombreInforme;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="nombreInforme"></param>
        /// <param name="col"></param>Para mostrar esta coleccin en el informe, en el origen de datos tiene que haber uno llamado "bind".
        public FVistaInforme(string nombreInforme, IEColeccion col) : this(nombreInforme) {
            rv.LocalReport.DataSources.Add(new Microsoft.Reporting.WinForms.ReportDataSource("bind", col));
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="nombreInforme"></param>
        /// <param name="col1"></param>
        /// <param name="col2"></param>Para mostrar esta coleccin en el informe, en el origen de datos tiene que haber uno llamado "bind2".
        public FVistaInforme(string nombreInforme, IEColeccion col1, IEColeccion col2) : this(nombreInforme, col1) {
            rv.LocalReport.DataSources.Add(new Microsoft.Reporting.WinForms.ReportDataSource("bind2", col2));
        }

        public FVistaInforme(string nombreInforme, EDocInformeFinal documento) : this(nombreInforme) {
            EColeccion<EDocumento> col = new EColeccion<EDocumento>();
            col.Add(documento);
            rv.LocalReport.DataSources.Add(new Microsoft.Reporting.WinForms.ReportDataSource("bind", col));
        }

        private void FVistaInforme_Load(object sender, EventArgs e) {
            this.rv.RefreshReport();
        }
    }
}