﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using Nibi.Dal;
using Nibi.Negocio;
using Negocio;
using Forms.Properties;
using System.IO;

namespace Forms
{
    static class Program
    {
        /// <summary>
        /// Punto de entrada principal para la aplicación.
        /// </summary>
        [STAThread]
        static void Main()
        {
            //Preguntamos si es la primera vez que se accede al sistema (numero de usuarios = 0).
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            bool fin = false;
            while (!fin) {
                fin = true;
                try {
                    string cadenaSettings = Settings.Default.RutaConexion;
                    int indice = cadenaSettings.IndexOf("Source=");
                    string cadenaConexion = "";
                    if (cadenaSettings.Substring(indice + 7).Equals("\\AutomovilismoB.mdb")) {
                        cadenaConexion = cadenaSettings.Replace(cadenaSettings.Substring(indice + 7), Application.StartupPath + "\\AutomovilismoB.mdb");
                    } else {
                        cadenaConexion = cadenaSettings;
                    }
                    FabrDBase.Actual = FabrDBase.CrearFabrD(cadenaConexion);
                    CentroImagenesE.Actual = new CentroImagenesE(Application.StartupPath + Settings.Default.RutaImagenes);
                    FabrFBase.Actual = new FabrFAutomovilismo();
                    EColeccion<EUsuario> col = EUsuario.GetCollection(true);
                    ETemporada.Actual = ETemporada.GetTemporadaActual();
                    Application.Run(new FAcceso(col));
                    //Application.Run(new FGaleria());
                } catch (DirectoryNotFoundException ex) {
                    fin = false;
                    MessageBox.Show(ex.Message, "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    if (ex.StackTrace.Contains("Centro")) {
                        DialogResult dr = MessageBox.Show("El error se produjo por no encontrar la ruta donde se guardan las imágenes.\n¿Quiere seleccionar una ruta válida?:\n(Si selecciona NO se aplicará la ruta por defecto)", "Cambio de directorio", MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
                        if (dr == DialogResult.Yes) {
                            FolderBrowserDialog folderDialog = new FolderBrowserDialog();
                            if (folderDialog.ShowDialog() == DialogResult.OK) {
                                Settings.Default.RutaImagenes = folderDialog.SelectedPath;
                                MessageBox.Show("Se ha cambiado la ruta correctamente.", "OK", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            } else {
                                MessageBox.Show("Se aplicará la ruta por defecto.", "Cambio de directorio", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                                Settings.Default.Reset();
                            }
                        } else {
                            MessageBox.Show("Se aplicará la ruta por defecto.", "Cambio de directorio", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                            Settings.Default.Reset();
                        }
                    } else if (ex.StackTrace.Contains("FabrDBase")) {
                        DialogResult dr = MessageBox.Show("El error se produjo por no encontrar la ruta de la base de datos.\n¿Quiere seleccionar una ruta válida?:\n(Si selecciona NO se aplicará la ruta por defecto)", "Cambio de directorio", MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
                        if (dr == DialogResult.Yes) {
                            OpenFileDialog openDialog = new OpenFileDialog();
                            if (openDialog.ShowDialog() == DialogResult.OK) {
                                string cadenaSettings = Settings.Default.RutaConexion;
                                int indice = cadenaSettings.IndexOf("Source=");
                                string nuevaConexion = cadenaSettings.Replace(cadenaSettings.Substring(indice + 7), openDialog.FileName);
                                Settings.Default.RutaConexion = nuevaConexion;
                                MessageBox.Show("Se ha cambiado la ruta.", "Cambio Directorio", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            } else {
                                MessageBox.Show("Se aplicará la ruta por defecto.", "Cambio de directorio", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                                Settings.Default.Reset();
                            }
                        } else {
                            MessageBox.Show("Se aplicará la ruta por defecto.", "Cambio de directorio", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                            Settings.Default.Reset();
                        }
                    }
                } catch (Exception ex) {
                    MessageBox.Show(ex.Message, "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    if (ex.StackTrace.Contains("FabrDBase")) {
                        DialogResult dr = MessageBox.Show("El error se produjo por no encontrar la ruta de la base de datos.\n¿Quiere seleccionar una ruta válida?:\n(Si selecciona NO se aplicará la ruta por defecto)", "Cambio de directorio", MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
                        if (dr == DialogResult.Yes) {
                            OpenFileDialog openDialog = new OpenFileDialog();
                            if (openDialog.ShowDialog() == DialogResult.OK) {
                                string cadenaSettings = Settings.Default.RutaConexion;
                                int indice = cadenaSettings.IndexOf("Source=");
                                string nuevaConexion = cadenaSettings.Replace(cadenaSettings.Substring(indice + 7), openDialog.FileName);
                                Settings.Default.RutaConexion = nuevaConexion;
                                MessageBox.Show("Se ha cambiado la ruta.", "Cambio Directorio", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            } else {
                                MessageBox.Show("Se aplicará la ruta por defecto.", "Cambio de directorio", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                                Settings.Default.Reset();
                            }
                        } else {
                            MessageBox.Show("Se aplicará la ruta por defecto.", "Cambio de directorio", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                            Settings.Default.Reset();
                        }
                    }
                    fin = false;
                } finally {
                    Settings.Default.Save();
                }
            }
            //Application.Run(new FPrincipal());
        }
    }
}
