using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Negocio;
using Nibi.Negocio;

namespace Forms {
    public partial class FMantenimiento : Form {

        private FListados flistados;

        public FMantenimiento() {
            InitializeComponent();
        }

        public FMantenimiento(Size s, Point p, FormWindowState ws) : this() {
            if (ws == FormWindowState.Maximized) {
                this.WindowState = FormWindowState.Maximized;
            } else {
                this.Size = s;
                this.Location = p;
            }
        }

        private void FMantenimiento_Load(object sender, EventArgs e) {
        }

        private void btSalir_Click(object sender, EventArgs e){
            if(flistados != null) {
                flistados.Close();
            }
            this.Close();
        }

        private void MostrarForm(IEColeccion eColeccion) {
            if(flistados != null) {
                //flistados.Close();
                flistados.CambiarColeccion(eColeccion, true);
            } else {
                lblTitulo.Visible = false;
                flistados = new FListados(eColeccion);
                flistados.FormClosed += new FormClosedEventHandler(flistados_FormClosed);
                flistados.TopLevel = false;
                flistados.Parent = pVentana;
                flistados.FormBorderStyle = FormBorderStyle.None;
                pVentana.Controls.Add(flistados);
                pVentana.Visible = true;
                flistados.Dock = DockStyle.Fill;
                flistados.Show();
            }
        }

        void flistados_FormClosed(object sender, FormClosedEventArgs e) {
            flistados = null;
            lblTitulo.Visible = true;
        }

        private void btOficiales_Click(object sender, EventArgs e){
            MostrarForm(EOficial.GetCollection(true));
        }

        private void btLicencias_Click(object sender, EventArgs e) {
            MostrarForm(ELicencia.GetCollection(true));
        }

        private void btPilotos_Click(object sender, EventArgs e) {
            MostrarForm(EPiloto.GetCollection(true));
        }

        private void btCopilotos_Click(object sender, EventArgs e) {
            MostrarForm(ECopiloto.GetCollection(true));
        }

        private void btSubidas_Click(object sender, EventArgs e) {
            try {
                MostrarForm(ESubida.GetCollection(true, false));
            } catch(Exception ex) {
                MessageBox.Show(ex.Message);
            }
        }

        private void btEscuderias_Click(object sender, EventArgs e) {
            MostrarForm(EEscuderia.GetCollection(true));
        }

        private void btCampeonatos_Click(object sender, EventArgs e) {
            MostrarForm(ECampeonato.GetCollection(true, 0, false));
        }

        private void btRallys_Click(object sender, EventArgs e) {
            MostrarForm(ERally.GetCollection(true, false));
        }
    }
}