using System.ComponentModel;

using Nibi.Dal;
using Nibi.Negocio;

namespace Negocio {

    [Tabla("ClasificacionesGenerales")]
    public class EClasificacionGeneralCopiloto : EClasificacionGeneralParticipante {

        #region Constructores

        public EClasificacionGeneralCopiloto() : base() { }

        public EClasificacionGeneralCopiloto(int vId) : base(vId) { }

        public EClasificacionGeneralCopiloto(ECopiloto participante) : base() {
            mCopiloto = participante;
        }

        #endregion

        #region Sobrecargas de EBase

        protected override void InicializarObjetoNuevo() {
            base.InicializarObjetoNuevo();
            TipoClasificaciongeneral = TipoClasificacionGeneral.Copiloto;
        }

        public override bool EsMasculino {
            get { return false; }
        }

        public override string NombreDeLaEntidad {
            get { return "ClasifGeneralCopiloto"; }
        }

        public override bool Modificable(string nombreProp) {
            if (!EstaCargado) return true;

            switch (nombreProp) {
                default:
                    return true;
            }
        }

        [Browsable(false)]
        public override string NPToString {
            get { return NPPuesto; }
        }
        #endregion

        #region Propiedades

        public override EParticipante Participante {
            get {
                return Copiloto;
            }
            //set {
            //    Copiloto = value as ECopiloto;
            //}
        }

        public const string NPCopiloto = "Copiloto";
        private ECopiloto mCopiloto;

        [Campo("ParticipacionId"), Requerido]
        public ECopiloto Copiloto {
            get {
                PrePropertyRead(NPCopiloto);
                return mCopiloto;
            }
            set {
                PrePropertyChanged(NPCopiloto);
                mCopiloto = value;
                OnPropertyChanged(NPCopiloto);
            }
        }

        #endregion

        #region Colecciones
        public static EColeccion<EClasificacionGeneralCopiloto> GetCollection() {
            return GetCollection(false, false);
        }

        public static EColeccion<EClasificacionGeneralCopiloto> GetCollection(bool vacio, bool asincronamente) {
            EColeccion<EClasificacionGeneralCopiloto> col = new EColeccion<EClasificacionGeneralCopiloto>();
            col.ColumnaMostrarRango(new string[] { NPPuesto, NPPuntos });
            if (!vacio)
                col.Cargar(asincronamente);
            return col;
        }
        #endregion
    }
}