using System.ComponentModel;

using Nibi.Dal;
using Nibi.Negocio;

namespace Negocio {

    [Tabla("ClasificacionesGenerales")]
    public class EClasificacionGeneralPareja : EClasificacionGeneralBase {

        #region Constructores
        public EClasificacionGeneralPareja() : base() { }

        public EClasificacionGeneralPareja(int vId) : base(vId) { }

        public EClasificacionGeneralPareja(EPareja pareja) : base() {
            this.Pareja = pareja;
        }
        #endregion

        #region Sobrecargas de EBase

        protected override void InicializarObjetoNuevo() {
            base.InicializarObjetoNuevo();
            TipoClasificaciongeneral = TipoClasificacionGeneral.Pareja;
        }

        protected override void GuardarCore() {
            using (AmbitoTransa transa = this.CrearAmbitoTransa("Guardar ClasificacionGeneralPareja")) {
                base.GuardarCore();
                transa.Commit();
            }
        }

        public override bool EsMasculino {
            get { return false; }
        }

        public override string NombreDeLaEntidad {
            get { return "ClasificacionGeneralPareja"; }
        }

        public override bool Modificable(string nombreProp) {
            if (!EstaCargado) return true;

            switch (nombreProp) {
                default:
                    return true;
            }
        }

        [Browsable(false)]
        public override string NPToString {
            get { return NPPuesto; }
        }
        #endregion

        #region Propiedades

        public const string NPPareja = "Pareja";
        private EPareja mPareja;

        [Campo("ParticipacionId"), Requerido]
        public EPareja Pareja {
            get {
                PrePropertyRead(NPPareja);
                return mPareja;
            }
            set {
                PrePropertyChanged(NPPareja);
                mPareja = value;
                OnPropertyChanged(NPPareja);
            }
        }

        public override string NombreConcursante {
            get { return this.Pareja.ToString(); }
        }

        #endregion

        #region Colecciones

        public static EColeccion<EClasificacionGeneralPareja> GetCollection() {
            return GetCollection(false, false);
        }

        public static EColeccion<EClasificacionGeneralPareja> GetCollection(bool vacio, bool asincronamente) {
            EColeccion<EClasificacionGeneralPareja> col = new EColeccion<EClasificacionGeneralPareja>();
            col.ColumnaMostrarRango(new string[] { NPPareja, NPCampeonato, NPPuesto, NPPuntos });
            if (!vacio)
                col.Cargar(asincronamente);
            return col;
        }

        #endregion
    }
}

