using System.ComponentModel;

using Nibi.Dal;
using Nibi.Negocio;

namespace Negocio {

    [Tabla("ClasificacionesGenerales")]
    public abstract class EClasificacionGeneralParticipante : EClasificacionGeneralBase {

        #region Constructores

        public EClasificacionGeneralParticipante() : base() { }

        public EClasificacionGeneralParticipante(int vId) : base(vId) { }

        #endregion

        #region Sobrecargas de EBase

        protected override void InicializarObjetoNuevo() {
            base.InicializarObjetoNuevo();
        }

        public override bool EsMasculino {
            get { return false; }  
        }

        public override string NombreDeLaEntidad {
            get { return "ClasifGeneralParticipante"; }
        }

        public override bool Modificable(string nombreProp) {
            if (!EstaCargado) return true;

            switch (nombreProp) {
                default:
                    return true;
            }
        }

        [Browsable(false)]
        public override string NPToString {
            get { return NPPuesto; }
        }

        #endregion

        #region Propiedades

        public const string NPParticipante = "Participante";

        public abstract EParticipante Participante {
            get;
            //set;
        }

        public override string NombreConcursante {
            get { return this.Participante.ToString(); }
        }

        #endregion
    }
}
