using System.ComponentModel;

using Nibi.Dal;
using Nibi.Negocio;

namespace Negocio {

    [Tabla("ClasificacionesGenerales")]
    public class EClasificacionGeneralPiloto : EClasificacionGeneralParticipante {

        #region Constructores

        public EClasificacionGeneralPiloto() : base() { }

        public EClasificacionGeneralPiloto(int vId) : base(vId) { }

        public EClasificacionGeneralPiloto(EPiloto participante) : base() {
            mPiloto = participante;
        }

        #endregion

        #region Sobrecargas de EBase

        protected override void InicializarObjetoNuevo() {
            base.InicializarObjetoNuevo();
            TipoClasificaciongeneral = TipoClasificacionGeneral.Piloto;
        }

        public override bool EsMasculino {
            get { return false; }
        }

        public override string NombreDeLaEntidad {
            get { return "ClasifGeneralPiloto"; }
        }

        public override bool Modificable(string nombreProp) {
            if (!EstaCargado) return true;

            switch (nombreProp) {
                default:
                    return true;
            }
        }

        [Browsable(false)]
        public override string NPToString {
            get { return NPPuesto; }
        }

        #endregion

        #region Propiedades

        public override EParticipante Participante {
            get {
                return Piloto;
            }
            //set {
            //    Piloto = value as EPiloto;
            //}
        }

        public const string NPPiloto = "Piloto";
        private EPiloto mPiloto;

        [Campo("ParticipacionId"), Requerido]
        public EPiloto Piloto {
            get {
                PrePropertyRead(NPPiloto);
                return mPiloto;
            }
            set {
                PrePropertyChanged(NPPiloto);
                mPiloto = value;
                OnPropertyChanged(NPPiloto);
            }
        }

        #endregion

        #region Colecciones
        public static EColeccion<EClasificacionGeneralPiloto> GetCollection() {
            return GetCollection(false, false);
        }

        public static EColeccion<EClasificacionGeneralPiloto> GetCollection(bool vacio, bool asincronamente) {
            EColeccion<EClasificacionGeneralPiloto> col = new EColeccion<EClasificacionGeneralPiloto>();
            col.ColumnaMostrarRango(new string[] { NPPuesto, NPPuntos });
            if (!vacio)
                col.Cargar(asincronamente);
            return col;
        }
        #endregion
    }
}
