using System;
using System.Collections.Generic;
using System.Text;

namespace Negocio {

    public abstract class CalculadorPuntos {

        public CalculadorPuntos(ECampeonatoPuntuable campeonatoPuntuable) {
            mCampeonatoPuntuable = campeonatoPuntuable;
        }

        public abstract TipoCalculoPuntos TipoCalculador { get;}

        public const string NPCampeonatoPuntuable = "CampeonatoPuntuable";
        private ECampeonatoPuntuable mCampeonatoPuntuable;

        public ECampeonatoPuntuable CampeonatoPuntuable { 
            get {
                return mCampeonatoPuntuable;
            }
        }

        /// <summary>
        /// Devuelve los puntos obtenidos
        /// </summary>
        /// <param name="puesto"></param> El puesto del participante
        /// <param name="numVehiculos"></param> El nmero de vehculos de la clase de la que se est calculando los puntos
        /// (si el clculo es con tabla fija, este valor no se utiliza).
        /// <returns></returns>
        public abstract int DevolverPuntos(int puesto, int numVehiculos);
    }
}
