using System;
using System.Collections.Generic;
using System.Text;
using Nibi.Negocio;
using System.ComponentModel;

namespace Negocio {
    public class CalculadorTablaFija : CalculadorPuntos {

        public CalculadorTablaFija(ECampeonatoPuntuable campeonatoPuntuable) : base(campeonatoPuntuable) { }

        public void Deshacer() {
            mTabla = null;
        }

        public override TipoCalculoPuntos TipoCalculador {
            get { return TipoCalculoPuntos.TFija; }
        }

        #region Tabla

        public const string NPTabla = "Tabla";
        private EColeccion<ETablaFija> mTabla = null;

        /// <summary>Devuelve una coleccin con todos las Tablas.</summary>
        public EColeccion<ETablaFija> Tabla {
            get {
                if(mTabla == null) {
                    mTabla = new EColeccion<ETablaFija>();
                    if(!this.CampeonatoPuntuable.EsNuevo) {
                        mTabla.Filtros.Add(ETablaFija.NPCampeonatoPuntuable, this.CampeonatoPuntuable);
                        mTabla.Cargar();
                    }
                    mTabla.AddingNew += new AddingNewEventHandler(mTabla_AddingNew);
                }
                return mTabla;
            }
        }

        void mTabla_AddingNew(object sender, AddingNewEventArgs e) {
            ETablaFija entidad = new ETablaFija();
            entidad.CampeonatoPuntuable = this.CampeonatoPuntuable;
            e.NewObject = entidad;
        }

        #endregion

        public override int DevolverPuntos(int puesto, int numVehiculos) {
            if (puesto > 0) {
                EColeccion<ETablaFija> col = Tabla;
                foreach (ETablaFija tfija in col) {
                    if (tfija.Puesto == puesto) {
                        return tfija.Puntos;
                    }
                }
            }
            return 0;
        }

        public bool TablaConPuestosDuplicados() {
            int actual = 0;
            while (actual < Tabla.Count - 1) {
                for (int itfija = actual + 1; itfija < Tabla.Count; itfija++) {
                    if (Tabla[actual].Puesto == Tabla[itfija].Puesto) {
                        return true;
                    }
                }
                actual = actual + 1;
            }
            return false;
        }
    }
}
