using System.ComponentModel;

using Nibi.Dal;
using Nibi.Negocio;

namespace Negocio {

    [Tabla("AsistenciasBriefing")]
    public class EAsistenciaBriefing : EIdBase {
        #region Constructores

        public EAsistenciaBriefing() : base() { }

        public EAsistenciaBriefing(int vId) : base(vId) { }

        #endregion

        #region Sobrecargas de EBase

        protected override void InicializarObjetoNuevo() {
        }

        public override bool EsMasculino {
            get { return true; }
        }

        public override string NombreDeLaEntidad {
            get { return "AsistenciaBriefing"; }
        }

        public override bool Modificable(string nombreProp) {
            if (!EstaCargado) return true;

            switch (nombreProp) {
                default:
                    return true;
            }
        }

        [Browsable(false)]
        public override string NPToString {
            get { return ""; }
        }
        #endregion

        #region Propiedades

        public const string NPPilotoCarrera = "PilotoCarrera";
        private EPilotoCarrera mPilotoCarrera;

        [Campo("PilotoCarreraId"), Requerido]
        public EPilotoCarrera PilotoCarrera {
            get {
                PrePropertyRead(NPPilotoCarrera);
                return mPilotoCarrera;
            }
            set {
                PrePropertyChanged(NPPilotoCarrera);
                mPilotoCarrera = value;
                OnPropertyChanged(NPPilotoCarrera);
            }
        }

        public const string NPDocumentoAsistenciaBriefing = "DocumentoAsistenciaBriefing";
        private EDocListaBriefing mDocumentoAsistenciaBriefing;

        [Campo("DocumentoId"), Requerido]
        public EDocListaBriefing DocumentoAsistenciaBriefing {
            get {
                PrePropertyRead(NPDocumentoAsistenciaBriefing);
                return mDocumentoAsistenciaBriefing;
            }
            set {
                PrePropertyChanged(NPDocumentoAsistenciaBriefing);
                mDocumentoAsistenciaBriefing = value;
                OnPropertyChanged(NPDocumentoAsistenciaBriefing);
            }
        }

        #region Imprimir

        public string CarreraToString {
            get {
                if (DocumentoAsistenciaBriefing != null) {
                    return DocumentoAsistenciaBriefing.CarreraToString;
                }
                return "";
            }
        }

        public string DorsalToString {
            get {
                if (PilotoCarrera != null) {
                    return PilotoCarrera.Dorsal.ToString();
                }
                return "";
            }
        }

        public string ParticipanteToString {
            get {
                if (PilotoCarrera != null) {
                    string res = PilotoCarrera.Piloto.ToString();
                    if (PilotoCarrera.Copiloto != null) {
                        res += "\n" + PilotoCarrera.Copiloto.ToString();
                    }
                    return res;
                }
                return "";
            }
        }

        public string EscuderiaToString {
            get {
                if (PilotoCarrera != null && PilotoCarrera.Piloto.Escuderia != null) {
                    return PilotoCarrera.Piloto.Escuderia.ToString();
                }
                return "";
            }
        }

        public string CodigoToString {
            get {
                if (DocumentoAsistenciaBriefing != null) {
                    return DocumentoAsistenciaBriefing.Codigo.ToString();
                }
                return "";
            }
        }

        public string FechaDocToString {
            get {
                if (DocumentoAsistenciaBriefing != null) {
                    return DocumentoAsistenciaBriefing.FechaToString;
                }
                return "";
            }
        }

        public string EmisorToString {
            get {
                if (DocumentoAsistenciaBriefing != null && DocumentoAsistenciaBriefing.Emisor != TipoCargoOficial.Ninguno) {
                    return DocumentoAsistenciaBriefing.EmisorToString;
                }
                return "";
            }
        }

        public string ReceptoresToString {
            get {
                if (DocumentoAsistenciaBriefing != null) {
                    return DocumentoAsistenciaBriefing.ReceptoresToString;
                }
                return "";
            }
        }

        #endregion

        #endregion
    }
}

