using System.ComponentModel;

using Nibi.Dal;
using Nibi.Negocio;

namespace Negocio {

    [Tabla("ReceptoresDocumentos")]
    public class EReceptor : EIdBase {
        #region Constructores

        public EReceptor() : base() { }

        public EReceptor(int vId) : base(vId) { }

        #endregion

        #region Sobrecargas de EBase

        protected override void InicializarObjetoNuevo() {
        }

        public override bool EsMasculino {
            get { return true; } 
        }

        public override string NombreDeLaEntidad {
            get { return "Receptor"; }
        }

        public override bool Modificable(string nombreProp) {
            if (!EstaCargado) return true;

            switch (nombreProp) {
                default:
                    return true;
            }
        }

        [Browsable(false)]
        public override string NPToString {
            get { return this.ToString(); }
        }
        #endregion

        #region Propiedades

        public const string NPReceptor = "Receptor";
        private TipoCargoOficial mReceptor;

        [Campo, Requerido]
        public TipoCargoOficial Receptor {
            get {
                PrePropertyRead(NPReceptor);
                return mReceptor;
            }
            set {
                PrePropertyChanged(NPReceptor);
                mReceptor = value;
                OnPropertyChanged(NPReceptor);
            }
        }

        public const string NPDocumento = "Documento";
        private EDocumento mDocumento;

        [Campo("DocumentoId"), Requerido]
        public EDocumento Documento {
            get {
                PrePropertyRead(NPDocumento);
                return mDocumento;
            }
            set {
                PrePropertyChanged(NPDocumento);
                mDocumento = value;
                OnPropertyChanged(NPDocumento);
            }
        }

        #endregion

        public override string ToString() {
            EnumConvert ec = new EnumConvert();
            return ec.GetDescription(this.Receptor);
        }
    }
}
