using System.ComponentModel;

using Nibi.Dal;
using Nibi.Negocio;

namespace Negocio {

    [Tabla("LicenciasNumeradas")]
    public class ELicenciaCopiloto : ELicenciaNumerada {
        #region Constructores
        public ELicenciaCopiloto() : base() { }

        public ELicenciaCopiloto(int vId) : base(vId) { }

        public ELicenciaCopiloto(string num) : base(num) { }
        #endregion

        #region Sobrecargas de EBase
        protected override void InicializarObjetoNuevo() {
            base.InicializarObjetoNuevo();
            Copiloto = null;
        }

        public override bool EsMasculino {
            get { return false; }  
        }

        public override string NombreDeLaEntidad {
            get { return "LicenciaCopiloto"; }
        }

        public override bool Modificable(string nombreProp) {
            if (!EstaCargado) return true;

            switch (nombreProp) {
                default:
                    return true;
            }
        }

        [Browsable(false)]
        public override string NPToString {
            get { return NPNumero; }
        }
        #endregion

        #region Propiedades

        public const string NPCopiloto = "Copiloto";
        private ECopiloto mCopiloto;

        [Campo("PersonaId"), Requerido]
        public ECopiloto Copiloto {
            get {
                PrePropertyRead(NPCopiloto);
                return mCopiloto;
            }
            set {
                PrePropertyChanged(NPCopiloto);
                mCopiloto = value;
                OnPropertyChanged(NPCopiloto);
            }
        }


        #endregion
    }
}

