using System.ComponentModel;

using Nibi.Dal;
using Nibi.Negocio;

namespace Negocio {

    [Tabla("LicenciasNumeradas")]
    public class ELicenciaEscuderia : ELicenciaNumerada {
        #region Constructores
        public ELicenciaEscuderia() : base() { }

        public ELicenciaEscuderia(int vId) : base(vId) { }

        public ELicenciaEscuderia(string num) : base(num) { }
        #endregion

        #region Sobrecargas de EBase
        protected override void InicializarObjetoNuevo() {
            Escuderia = null;
        }

        public override bool EsMasculino {
            get { return false; }
        }

        public override string NombreDeLaEntidad {
            get { return "LicenciaEscuderia"; }
        }

        public override bool Modificable(string nombreProp) {
            if (!EstaCargado) return true;

            switch (nombreProp) {
                default:
                    return true;
            }
        }

        [Browsable(false)]
        public override string NPToString {
            get { return NPNumero; } 
        }
        #endregion

        #region Propiedades

        public const string NPEscuderia = "Escuderia";
        private EEscuderia mEscuderia;

        [Campo("EscuderiaId")]
        public EEscuderia Escuderia {
            get {
                PrePropertyRead(NPEscuderia);
                return mEscuderia;
            }
            set {
                PrePropertyChanged(NPEscuderia);
                mEscuderia = value;
                OnPropertyChanged(NPEscuderia);
            }
        }

        
        #endregion
    }
}

