using System.ComponentModel;

using Nibi.Dal;
using Nibi.Negocio;
using System;

namespace Negocio {

    [Tabla("LicenciasNumeradas")]
    public class ELicenciaNumerada : EIdBase {
        #region Constructores
        public ELicenciaNumerada() : base() { }

        public ELicenciaNumerada(int vId) : base(vId) { }

        public ELicenciaNumerada(string num) : this() {
            this.Cargar(NPNumero, num);
        }
        #endregion

        #region Sobrecargas de EBase
        protected override void InicializarObjetoNuevo() {
            Numero = null;
            Licencia = null;
        }

        public override bool EsMasculino {
            get { return false; } 
        }

        public override string NombreDeLaEntidad {
            get { return "Licencia Numerada"; }
        }

        public override bool Modificable(string nombreProp) {
            if (!EstaCargado) return true;

            switch (nombreProp) {
                default:
                    return true;
            }
        }

        [Browsable(false)]
        public override string NPToString {
            get { return NPNumero; }
        }
        #endregion

        #region Propiedades

        public const string NPNumero = "Numero";
        private string mNumero;

        [Campo(Tamanyo=50), Requerido, Unico]
        public string Numero {
            get {
                PrePropertyRead(NPNumero);
                return mNumero;
            }
            set {
                PrePropertyChanged(NPNumero);
                mNumero = value;
                OnPropertyChanged(NPNumero);
            }
        }

        public const string NPLicencia = "Licencia";
        private ELicencia mLicencia;

        [Campo("LicenciaId"), Requerido]
        public ELicencia Licencia
        {
            get
            {
                PrePropertyRead(NPLicencia);
                return mLicencia;
            }
            set
            {
                PrePropertyChanged(NPLicencia);
                mLicencia = value;
                OnPropertyChanged(NPLicencia);
            }
        }

        public const string NPFechaCaducidad = "FechaCaducidad";
        private DateTime mFechaCaducidad;

        [Campo]
        public DateTime FechaCaducidad {
            get {
                PrePropertyRead(NPFechaCaducidad);
                return mFechaCaducidad;
            }
            set {
                PrePropertyChanged(NPFechaCaducidad);
                mFechaCaducidad = value;
                OnPropertyChanged(NPFechaCaducidad);
            }
        }


        #endregion
    }
}
