using System.ComponentModel;

using Nibi.Dal;
using Nibi.Negocio;

namespace Negocio {

    [Tabla("LicenciasNumeradas")]
    public class ELicenciaPiloto : ELicenciaNumerada {
        #region Constructores
        public ELicenciaPiloto() : base() { }

        public ELicenciaPiloto(int vId) : base(vId) { }

        public ELicenciaPiloto(string num) : base(num) { }
        #endregion

        #region Sobrecargas de EBase
        protected override void InicializarObjetoNuevo() {
            base.InicializarObjetoNuevo();
            Piloto = null;
        }

        public override bool EsMasculino {
            get { return false; }  
        }

        public override string NombreDeLaEntidad {
            get { return "LicenciaPiloto"; }
        }

        public override bool Modificable(string nombreProp) {
            if (!EstaCargado) return true;

            switch (nombreProp) {
                default:
                    return true;
            }
        }

        [Browsable(false)]
        public override string NPToString {
            get { return NPNumero; } 
        }
        #endregion

        #region Propiedades

        public const string NPPiloto = "Piloto";
        private EPiloto mPiloto;

        [Campo("PersonaId"), Requerido]
        public EPiloto Piloto {
            get {
                PrePropertyRead(NPPiloto);
                return mPiloto;
            }
            set {
                PrePropertyChanged(NPPiloto);
                mPiloto = value;
                OnPropertyChanged(NPPiloto);
            }
        }
        
        #endregion
    }
}

