using System;
using System.Collections.Generic;
using System.Text;

namespace Negocio {
    public static class CToString {

        /// <summary>
        ///Devuelve un tiempo en formato hh:mm:ss:mmm
        /// </summary>
        /// <param name="tiempo"></param>
        /// <returns></returns>
        public static string ToString(TimeSpan tiempo) {
            string horas = tiempo.Hours.ToString();
            if (horas.Length < 2) {
                horas = "0" + horas;
            }
            string minutos = tiempo.Minutes.ToString();
            if (minutos.Length < 2) {
                minutos = "0" + minutos;
            }
            string segundos = tiempo.Seconds.ToString();
            if (segundos.Length < 2) {
                segundos = "0" + segundos;
            }
            string milesimas = tiempo.Milliseconds.ToString();
            if (milesimas.Length < 3) {
                if (milesimas.Length < 2) {
                    milesimas = "00" + milesimas;
                } else {
                    milesimas = "0" + milesimas;
                }
            }
            return horas + " : " + minutos + " : " + segundos + " : " + milesimas;
        }

        /// <summary>
        /// Devuelve una cadena con formato dd:mm:aaaa ; hh:mm
        /// </summary>
        /// <param name="fecha"></param>
        /// <returns></returns>
        public static string ToString(DateTime fecha) {
            return fecha.Day.ToString() + " / " + fecha.Month.ToString() + " / " + fecha.Year.ToString() + " ; " + fecha.Hour.ToString() + " : " + fecha.Minute.ToString();
        }

        /// <summary>
        /// Devuelve una cadena con formato hh:mm
        /// </summary>
        /// <param name="horas"></param>
        /// <param name="minutos"></param>
        /// <returns></returns>
        public static string ToString(int horas, int minutos) {
            string horaString = horas.ToString();
            if (horaString.Length < 2) {
                horaString = "0" + horaString;
            }
            string minutoString = minutos.ToString();
            if (minutoString.Length < 2) {
                minutoString = "0" + minutoString;
            }
            return horaString + " : " + minutoString;
        }
    }
}
